//   
abstract class NeuralNetwork
{
	int N_input; //     
	int N_hidden; //     
	double [][] W; //      
	double [] V; //       

	double [] input;// 
	double [] hidden;//   
	double output;// 

	//        
	public NeuralNetwork(int N1, int N2, double [] V1, double [][] W1)
	{
		N_input = N1; //    
		N_hidden = N2; //    

		W = new double [N_input][N_hidden]; //      
		V = new double [N_hidden]; //       

		//  
		for(int j = 0; j < N_hidden; j++)
		{
			V[j] = V1[j];
			for(int i = 0; i < N_input; i++)
				W[i][j] = W1[i][j];
		}
	
		input = new double[N_input]; // 
		hidden = new double[N_hidden]; //   
	}

	//  
	double work(double [] in)
	{
		//  
		for(int i = 0; i < N_input; i++)
			input[i] = in[i];
		
		//    
		for(int j = 0; j < N_hidden; j++)
		{
			double sum = 0;
			for(int i = 0; i < N_input; i++)
				sum += W[i][j]*input[i];
			hidden[j] = th(sum);
		}

		//  
		output = 0;
		for(int j = 0; j < N_hidden; j++)
			output += V[j]*hidden[j];
				
		return output;
	}

	double th(double x)
	{
		return (Math.exp(x) - Math.exp(-x)) / (Math.exp(x) + Math.exp(-x));
	}	
}